<?php
namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\Report\Strategy\BirtStrategy;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Row;

class QuantidadeRefeicoesDiaController extends \Zeedhi\Framework\Controller\Report {

    protected $environment;
    protected $birtStrategy;
    protected $connection;
    protected $crudService;

    public function __construct(ReportService $reportService, $environment, $connection, $birtStrategy, $crudService) {
        $this->environment = $environment;
        $this->connection = $connection;
        $this->birtStrategy = $birtStrategy;
        $this->crudService = $crudService;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'PCP00039' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"     => "CDFILIAL",
              "CDCIA"        => "CDCIA",
              "DTINICIAL"    => "DTINICIAL",
              "DTFINAL"      => "DTFINAL",
              "NRORG"        => "NRORG",
              "REPORTFORMAT" => "__format"
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
        $row['NRORG'] = $this->environment->getNrOrgTrab();
    }
}