<?php
namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\Report\Strategy\BirtStrategy;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class RelatorioPrevisaoPassageiros extends \Zeedhi\Framework\Controller\Report {

    protected $environment;
    protected $birtStrategy;
    protected $connection;
    protected $crudService;

    public function __construct(ReportService $reportService, $environment, $connection, $birtStrategy, $crudService) {
        $this->environment = $environment;
        $this->connection = $connection;
        $this->birtStrategy = $birtStrategy;
        $this->crudService = $crudService;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'PCP00350' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"         => "CDFILIAL",
              "DTREFINI"         => "DTREFINI",
              "DTREFFIM"         => "DTREFFIM",
              "T_CIA"            => "T_CIA",
              "NRORG"            => "NRORG",
              "REPORTFORMAT"     => "__format"
            )
        ),
        'PCP00313' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"         => "CDFILIAL",
              "DTREFINI"         => "DTREFINI",
              "DTREFFIM"         => "DTREFFIM",
              "T_CIA"            => "T_CIA",
              "NRORG"            => "NRORG",
              "REPORTFORMAT"     => "__format"
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
        $row['NRORG'] = $this->environment->getNrOrgTrab();
    }
}